{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v2"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"iam.AuthorizeRequest":{"type":"object","description":"Authorization request","properties":{"actions":{"type":"array","description":"List of actions to check authorizations for","items":{"type":"string"}}},"required":["actions"]},"iam.AuthorizeResponse":{"type":"object","description":"Result of an authorization request","properties":{"authorizedActions":{"type":"array","description":"Actions from your request that the caller is allowed to perform on the resource","items":{"type":"string"},"readOnly":true},"unauthorizedActions":{"type":"array","description":"Actions from your request that the caller is not allowed to perform on the resource","items":{"type":"string"},"readOnly":true}}},"iam.resource.Resource":{"type":"object","description":"Resource is an entity standing for a product. It is used for right delegation.","properties":{"displayName":{"type":"string","description":"Resource display name","readOnly":true},"id":{"type":"string","description":"Identifier of the resource","format":"uuid","readOnly":true},"name":{"type":"string","description":"Resource name","readOnly":true},"owner":{"type":"string","description":"Resource owner","readOnly":true},"tags":{"type":"object","description":"Resource tags. Tags that were internally computed are prefixed with ovh:","nullable":true,"additionalProperties":{"type":"string"}},"type":{"type":"string","description":"Resource type. All types can be retrieved at /reference/resource/type.","readOnly":true},"urn":{"type":"string","description":"Unique resource name used in policies","readOnly":true}}},"iam.resource.TagFilter":{"type":"object","description":"Resource tag filter","properties":{"operator":{"allOf":[{"$ref":"#/components/schemas/iam.resource.TagFilter.OperatorEnum"}],"description":"Operator to use in order to filter on the value. Defaults to `EQ`.","nullable":true,"readOnly":true},"value":{"type":"string","description":"Value to use in order to filter tags","readOnly":true}}},"iam.resource.TagFilter.OperatorEnum":{"type":"string","description":"Operator that can be used in order to filter resources tags","enum":["EQ","EXISTS","ILIKE","LIKE","NEQ","NEXISTS"]},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/iam/resource":{"get":{"operationId":"getAllIamResources","summary":"List resources","description":"Returns the resources of the account. Filter by `resourceType`, `resourceName`, `resourceURN` pattern and tag filters.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"header","name":"X-Pagination-Cursor","description":"Pagination cursor","schema":{"type":"string"}},{"in":"header","name":"X-Pagination-Size","description":"Pagination size","schema":{"type":"integer"}},{"in":"query","name":"resourceName","description":"Filter resources for specific resource names","schema":{"type":"array","items":{"type":"string"}}},{"in":"query","name":"resourceType","description":"Filter resources for specific resource types","schema":{"type":"array","items":{"type":"string"}}},{"in":"query","name":"resourceURN","description":"Filter resources for specific resource URN patterns","schema":{"type":"array","items":{"type":"string"}}},{"in":"query","name":"tags","description":"Filter resources using tag filters","schema":{"type":"object","additionalProperties":{"type":"array","items":{"$ref":"#/components/schemas/iam.resource.TagFilter"}}}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/iam.resource.Resource"}},"examples":{"Get resources":{"value":[{"displayName":"Production dedicated server","id":"5d0e28e2-306e-11ee-8dad-0050568ce122","name":"ns-123456.ip-11.22.33.eu","owner":"aa1-ovh","tags":{"environment":"production","team":"website"},"type":"dedicatedServer","urn":"urn:v1:eu:resource:dedicatedServer:ns-123456.ip-11.22.33.eu"}],"summary":"Response body returned when listing resources"}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Resources@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/iam/resource\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/iam/resource\");\n\nprint_r($result);\n?>"}],"x-response-identifier":"urn","x-expanded-response":"IamResourceResource"}},"/iam/resource/{resourceURN}":{"get":{"operationId":"getIamResource","summary":"Get a resource","description":"Returns the details of a resource identified by its URN.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"resourceURN","description":"ResourceURN","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.resource.Resource"},"examples":{"Get a resource":{"value":{"displayName":"Production dedicated server","id":"5d0e28e2-306e-11ee-8dad-0050568ce122","name":"ns-123456.ip-11.22.33.eu","owner":"aa1-ovh","tags":{"environment":"production","team":"website"},"type":"dedicatedServer","urn":"urn:v1:eu:resource:dedicatedServer:ns-123456.ip-11.22.33.eu"},"summary":"Response body returned when getting a resource"}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Resources@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/iam/resource/{resourceURN}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/iam/resource/{resourceURN}\");\n\nprint_r($result);\n?>"}],"x-response-identifier":"urn"}},"/iam/resource/{resourceURN}/authorization/check":{"post":{"operationId":"checkIamResourceAuthorizations","summary":"Check authorizations on a resource","description":"Checks the listed actions on this resource.\nReturns the actions that are authorized and those that are not.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"resourceURN","description":"ResourceURN","required":true,"schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.AuthorizeRequest"}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.AuthorizeResponse"}}}}},"tags":["Authorization","Resources"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Resources@@@30"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: iam.AuthorizeRequest\nresult = client.post(\"/v2/iam/resource/{resourceURN}/authorization/check\",\n\tactions = None, # List of actions to check authorizations for (type: array)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: iam.AuthorizeRequest\n$result = $ovh->post(\"/v2/iam/resource/{resourceURN}/authorization/check\", array(\n\tactions => null, // List of actions to check authorizations for (type: array)\n));\n\nprint_r($result);\n?>"}]}}},"tags":[{"name":"Resources","x-tag-expanded":false,"description":"Missing description"},{"name":"Authorization","x-tag-expanded":false,"description":"Missing description"}]}
